C
C    second - test program that sends an array of floats from the first process
C             of a group to the last, using send and recv
C
C
      integer function worker( argc, argv )
      integer argc
      integer argv
      include "mpif.h"
C
      integer rank, size, to, from, tag, count, i, ierr
      integer src, dest
      integer st_source, st_tag, st_count
C      MPI_Status status
      integer status(3)
      double precision data(100)

      call MPI_Init_( ierr )
      call MPI_Comm_rank_( MPI_COMM_WORLD, rank, ierr )
      call MPI_Comm_size_( MPI_COMM_WORLD, size, ierr )
      print *, "Process ", rank, " of ", size, " is alive"
C
      src = size - 1
      dest = 0
C      
      if (rank .eq. src) then
         to     = dest
         count  = 10
         tag    = 2001
         do 10 i=1, 10
 10         data(i) = i
         call MPI_Send_( data, count, MPI_DOUBLE, to, tag, 
     &                  MPI_COMM_WORLD, ierr )
         print *, rank, " sent"
         print *, (data(i),i=1,10)
      elseif (rank .eq. dest) then
         tag   = MPI_ANY_TAG
         count = 10		
         from  = MPI_ANY_SOURCE
         call MPI_Recv_(data, count, MPI_DOUBLE, from, tag, 
     &                 MPI_COMM_WORLD, status, ierr ) 
            
c         call MPI_Get_source( status, st_source )
c         call MPI_Get_tag(    status, st_tag )
c         call MPI_Get_count(  status, st_count )
         st_count  = status(1)
         st_source = status(2)
         st_tag    = status(3)
c         
         print *, "Status info: source = ", st_source, 
     &             " tag = ", st_tag, " count = ", st_count
         print *, rank, " received", (data(i),i=1,10)
      endif
        
        call MPI_Finalize_( ierr )
        print *, "Process ", rank, " exiting"
        return
        end

